Codeforces Round #369 (Div. 2)

A. Bus to Udayland

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

ZS the Coder and Chris the Baboon are travelling to Udayland! To get there, they have to get on the special IOI bus. The IOI bus has nrows of seats. There are 4 seats in each row, and the seats are separated into pairs by a walkway. When ZS and Chris came, some places in the bus was already occupied.

ZS and Chris are good friends. They insist to get a pair of neighbouring empty seats. Two seats are considered neighbouring if they are in the same row and in the same pair. Given the configuration of the bus, can you help ZS and Chris determine where they should sit?

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 1000) — the number of rows of seats in the bus.

Then, n lines follow. Each line contains exactly 5 characters, the first two of them denote the first pair of seats in the row, the third character denotes the walkway (it always equals '|') and the last two of them denote the second pair of seats in the row.

Each character, except the walkway, equals to 'O' or to 'X'. 'O' denotes an empty seat, 'X' denotes an occupied seat. See the sample cases for more details.

Output

If it is possible for Chris and ZS to sit at neighbouring empty seats, print "YES" (without quotes) in the first line. In the next n lines print the bus configuration, where the characters in the pair of seats for Chris and ZS is changed with characters '+'. Thus the configuration should differ from the input one by exactly two charaters (they should be equal to 'O' in the input and to '+' in the output).

If there is no pair of seats for Chris and ZS, print "NO" (without quotes) in a single line.

If there are multiple solutions, you may print any of them.

Examples

input

6
OO|OX
XO|XX
OX|OO
XX|OX
OO|OO
OO|XX

output

YES
++|OX
XO|XX
OX|OO
XX|OX
OO|OO
OO|XX

input

4
XO|OX
XO|XX
OX|OX
XX|OX

output

NO

input

5
XX|XX
XX|XX
XO|OX
XO|OO
OX|XO

output

YES
XX|XX
XX|XX
XO|OX
XO|++
OX|XO

Note

Note that the following is an incorrect configuration for the first sample case because the seats must be in the same pair.

O+|+X

XO|XX

OX|OO

XX|OX

OO|OO

OO|XX

By Gerry99, contest: Codeforces Round #369 (Div. 2), problem: (A) Bus to Udayland, Accepted#


#include <bits/stdc++.h>
const int INF = ~0U >> 1;
using namespace std;
char ch[1002][6], x, y;
int main(){
 int n;
 cin >> n;
 for(int i = 1; i <= n; i++){
  for(int j = 1; j <= 5; j++){
   cin >> ch[i][j];
  }
 }
 bool flag = 0;
 for(int i = 1; i <= n; i++){
  if(ch[i][1] == 'O' && ch[i][2] == 'O') {
   ch[i][1] = ch[i][2] = '+';
   flag = 1;
   break;
  }
  else if(ch[i][4] == 'O' && ch[i][5] == 'O') {
   ch[i][4] = ch[i][5] = '+';
   flag = 1;
   break;
  }
 }
 if(!flag) printf("NO\n");
 else {
  printf("YES\n");
  for(int i = 1; i <= n; i++){
   for(int j = 1; j <= 5; j++) cout << ch[i][j];
   cout << endl;
  }
 }
 return 0;
}






B. Chris and Magic Square

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

ZS the Coder and Chris the Baboon arrived at the entrance of Udayland. There is a n × n magic grid on the entrance which is filled with integers. Chris noticed that exactly one of the cells in the grid is empty, and to enter Udayland, they need to fill a positive integer into the empty cell.

Chris tried filling in random numbers but it didn't work. ZS the Coder realizes that they need to fill in a positive integer such that the numbers in the grid form a magic square. This means that he has to fill in a positive integer so that the sum of the numbers in each row of the grid (), each column of the grid (), and the two long diagonals of the grid (the main diagonal —  and the secondary diagonal — ) are equal.

Chris doesn't know what number to fill in. Can you help Chris find the correct positive integer to fill in or determine that it is impossible?

Input

The first line of the input contains a single integer n (1 ≤ n ≤ 500) — the number of rows and columns of the magic grid.

n lines follow, each of them contains n integers. The j-th number in the i-th of them denotes ai, j (1 ≤ ai, j ≤ 109 or ai, j = 0), the number in the i-th row and j-th column of the magic grid. If the corresponding cell is empty, ai, j will be equal to 0. Otherwise, ai, j is positive.

It is guaranteed that there is exactly one pair of integers i, j (1 ≤ i, j ≤ n) such that ai, j = 0.

Output

Output a single integer, the positive integer x (1 ≤ x ≤ 1018) that should be filled in the empty cell so that the whole grid becomes a magic square. If such positive integer x does not exist, output  - 1 instead.

If there are multiple solutions, you may print any of them.

Examples

input

3
4 0 2
3 5 7
8 1 6

output

9

input

4
1 1 1 1
1 1 0 1
1 1 1 1
1 1 1 1

output

1

input

4
1 1 1 1
1 1 0 1
1 1 2 1
1 1 1 1

output

-1

Note

In the first sample case, we can fill in 9 into the empty cell to make the resulting grid a magic square. Indeed,

The sum of numbers in each row is:

4 + 9 + 2 = 3 + 5 + 7 = 8 + 1 + 6 = 15.

The sum of numbers in each column is:

4 + 3 + 8 = 9 + 5 + 1 = 2 + 7 + 6 = 15.

The sum of numbers in the two diagonals is:

4 + 5 + 6 = 2 + 5 + 8 = 15.

In the third sample case, it is impossible to fill a number in the empty square such that the resulting grid is a magic square.


By Gerry99, contest: Codeforces Round #369 (Div. 2), problem: (B) Chris and Magic Square, Accepted#


#include <bits/stdc++.h>
const int INF = ~0U >> 1;
using namespace std;
int n;
long long a[502][502], needx, needy, x[502], y[502], valx, valy, hhx, hhy, dig1, dig2;
int main(){
 scanf("%d", &n);
 for(int i = 1; i <= n; i++){
  for(int j = 1; j <= n; j++){
   scanf("%lld", &a[i][j]);
   if(a[i][j] == 0) needx = i, needy = j;
  }
 }
 if(n == 1) return (printf("1\n")), 0;
 for(int i = 1; i <= n; i++){
  if(i != needx){
   for(int j = 1; j <= n; j++){
    x[i] += a[i][j];
   }
   if(valx == 0) valx = x[i];
   else if(valx != x[i]) return (printf("-1\n")), 0;
  }
 }
 for(int j = 1; j <= n; j++){
  if(j != needy){
   for(int i = 1; i <= n; i++){
    y[j] += a[i][j];
   }
   if(valx == 0) valx = y[j];
   else if(valx != y[j]) return (printf("-1\n")), 0;
  }
 }
 for(int i = 1; i <= n; i++){
  hhx += a[needx][i], hhy += a[i][needy];
 }
 if(hhx != hhy) return (printf("-1\n")), 0;
 else a[needx][needy] = valx - hhx;
 for(int i = 1; i <= n; i++)dig1 += a[i][i], dig2 += a[i][n - i + 1];
 if(dig1 != dig2 || a[needx][needy] <= 0 || dig1 != valx || dig2 != valx) printf("-1\n");
 else printf("%lld\n", a[needx][needy]);
 return 0;
}

C. Coloring Trees

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

ZS the Coder and Chris the Baboon has arrived at Udayland! They walked in the park where n trees grow. They decided to be naughty and color the trees in the park. The trees are numbered with integers from 1 to n from left to right.

Initially, tree i has color ci. ZS the Coder and Chris the Baboon recognizes only m different colors, so 0 ≤ ci ≤ m, where ci = 0 means that tree i is uncolored.

ZS the Coder and Chris the Baboon decides to color only the uncolored trees, i.e. the trees with ci = 0. They can color each of them them in any of the m colors from 1 to m. Coloring the i-th tree with color j requires exactly pi, j litres of paint.

The two friends define the beauty of a coloring of the trees as the minimum number of contiguous groups (each group contains some subsegment of trees) you can split all the n trees into so that each group contains trees of the same color. For example, if the colors of the trees from left to right are 2, 1, 1, 1, 3, 2, 2, 3, 1, 3, the beauty of the coloring is 7, since we can partition the trees into 7 contiguous groups of the same color : {2}, {1, 1, 1}, {3}, {2, 2}, {3}, {1}, {3}.

ZS the Coder and Chris the Baboon wants to color all uncolored trees so that the beauty of the coloring is exactly k. They need your help to determine the minimum amount of paint (in litres) needed to finish the job.

Please note that the friends can't color the trees that are already colored.

Input

The first line contains three integers, nm and k (1 ≤ k ≤ n ≤ 1001 ≤ m ≤ 100) — the number of trees, number of colors and beauty of the resulting coloring respectively.

The second line contains n integers c1, c2, ..., cn (0 ≤ ci ≤ m), the initial colors of the trees. ci equals to 0 if the tree number i is uncolored, otherwise the i-th tree has color ci.

Then n lines follow. Each of them contains m integers. The j-th number on the i-th of them line denotes pi, j (1 ≤ pi, j ≤ 109) — the amount of litres the friends need to color i-th tree with color jpi, j's are specified even for the initially colored trees, but such trees still can't be colored.

Output

Print a single integer, the minimum amount of paint needed to color the trees. If there are no valid tree colorings of beauty k, print  - 1.

Examples

input

3 2 2
0 0 0
1 2
3 4
5 6

output

10

input

3 2 2
2 1 2
1 3
2 4
3 5

output

-1

input

3 2 2
2 0 0
1 3
2 4
3 5

output

5

input

3 2 3
2 1 2
1 3
2 4
3 5

output

0

Note

In the first sample case, coloring the trees with colors 2, 1, 1 minimizes the amount of paint used, which equals to 2 + 3 + 5 = 10. Note that 1, 1, 1 would not be valid because the beauty of such coloring equals to 1 ({1, 1, 1} is a way to group the trees into a single group of the same color).

In the second sample case, all the trees are colored, but the beauty of the coloring is 3, so there is no valid coloring, and the answer is - 1.

In the last sample case, all the trees are colored and the beauty of the coloring matches k, so no paint is used and the answer is 0.

By Gerry99, contest: Codeforces Round #369 (Div. 2), problem: (C) Coloring Trees, Accepted#



#include <bits/stdc++.h>
const int INF = ~0U >> 1;
using namespace std;
int n, m, k;
long long w[102][102], dp[102][102][102], color[102];
int main(){ 
 scanf("%d%d%d", &n, &m, &k);
 for(int i = 1; i <= n; i++) scanf("%lld", &color[i]);
 for(int i = 1; i <= n; i++){
  for(int j = 1; j <= m; j++) scanf("%lld", &w[i][j]);
 }
 for(int i = 0; i <= n; i++){
  for(int j = 0; j <= k; j++){
   for(int l = 0; l <= m; l++) dp[i][j][l] = 1000000000000;
  }
 }
 if(color[1] > 0) dp[1][1][color[1]] = 0;
 else for(int i = 1; i <= m; i++) dp[1][1][i] = w[1][i];
 for(int i = 1; i <= n; i++){
  for(int j = 1; j <= min(k, i); j++){
   if(color[i] == 0){
    if(color[i - 1] == 0){
     for(int l = 1; l <= m; l++)
      for(int p = 1; p <= m; p++){
       if(l == p) dp[i][j][l] = min(dp[i][j][l], dp[i - 1][j][l] + w[i][l]);
       else dp[i][j][l] = min(dp[i][j][l], dp[i - 1][j - 1][p] + w[i][l]);
      }
    }
    else{
     for(int l = 1; l <= m; l++)
      if(l == color[i - 1]) dp[i][j][l] = min(dp[i][j][l], dp[i - 1][j][l] + w[i][l]);
      else dp[i][j][l] = min(dp[i][j][l], dp[i - 1][j - 1][color[i - 1]] + w[i][l]);
    }
   }
   else {
    if(color[i - 1] == 0){
     for(int l = 1; l <= m; l++) 
      if(l == color[i]) dp[i][j][color[i]] = min(dp[i][j][color[i]], dp[i - 1][j][color[i]]);
      else dp[i][j][color[i]] = min(dp[i][j][color[i]], dp[i - 1][j - 1][l]);
    }
    else{
     if(color[i] == color[i - 1]) dp[i][j][color[i]] = min(dp[i][j][color[i]], dp[i - 1][j][color[i]]);
     else dp[i][j][color[i]] = dp[i - 1][j - 1][color[i - 1]];
    }
   }
  }
 }
 long long ans = 1000000000000;
 if(color[n] == 0){
  for(int i = 1; i <= m; i++) {
   ans = min(ans, dp[n][k][i]);
  }
 }
 else ans = dp[n][k][color[n]];
 if(ans == 1000000000000) printf("-1\n");
 else printf("%lld\n", ans);
 return 0;
}

  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值